<?php

namespace App\Dto\Input;

use ApiPlatform\Metadata\ApiProperty;
use App\Dto\Output\ClientOutput;
use App\Dto\Output\ImageOutput;
use App\Dto\Output\PartitionOutput;
use App\Validator\Constraints\ClientsHaveSamePartitionCount;
use App\Validator\Constraints\OrganizationalUnitMulticastMode;
use App\Validator\Constraints\OrganizationalUnitMulticastPort;
use App\Validator\Constraints\OrganizationalUnitP2PMode;
use Symfony\Component\Serializer\Annotation\Groups;

final class BackupImageInput
{
    #[Groups(['image-image-repository:write'])]
    #[ApiProperty(description: 'The repository ip', example: "")]
    public ?string $repoIp = null;

    #[Groups(['image-image-repository:write'])]
    #[ApiProperty(description: 'The remote path', example: "")]
    public ?string $remotePath = null;
}