<?php

namespace App\Dto\Input;

use Symfony\Component\Serializer\Annotation\Groups;
use Symfony\Component\Validator\Constraints as Assert;
use OpenApi\Annotations as OA;

/**
 * @OA\Schema(
 *     description="Datos de entrada para obtener las branches de un repositorio Git",
 *     required={"repositoryName"}
 * )
 */
final class GetBranchesInput
{
    /**
     * @OA\Property(
     *     description="Nombre del repositorio Git",
     *     example="demo-oggit"
     * )
     */
    #[Groups(['repository:write'])]
    #[Assert\NotBlank(message: 'El nombre del repositorio es requerido')]
    public ?string $repositoryName = null;
} 