<?php

namespace App\Dto\Output;

use ApiPlatform\Metadata\Get;
use App\Entity\HardwareType;
use Symfony\Component\Serializer\Annotation\Groups;

#[Get(shortName: 'HardwareType')]
final class HardwareTypeOutput extends AbstractOutput
{
    #[Groups(['hardware-type:read', 'hardware:read'])]
    public string $name;

    public function __construct(HardwareType $hardwareType)
    {
        parent::__construct($hardwareType);

        $this->name = $hardwareType->getName();
    }
}