<?php

namespace App\Dto\Output;

use ApiPlatform\Metadata\Get;
use App\Entity\OperativeSystem;
use Symfony\Component\Serializer\Annotation\Groups;

#[Get(shortName: 'OperativeSystem')]
final class OperativeSystemOutput extends AbstractOutput
{
    #[Groups(['operative-system:read', 'partition:read', 'software-profile:read', 'client:read'])]
    public string $name;

    #[Groups(['operative-system:read'])]
    public \DateTime $createdAt;

    #[Groups(['operative-system:read'])]
    public ?string $createdBy = null;

    public function __construct(OperativeSystem $operativeSystem)
    {
        parent::__construct($operativeSystem);

        $this->name = $operativeSystem->getName();
        $this->createdAt = $operativeSystem->getCreatedAt();
        $this->createdBy = $operativeSystem->getCreatedBy();
    }
}