<?php

namespace App\Dto\Output;

use ApiPlatform\Metadata\ApiProperty;
use ApiPlatform\Metadata\Get;
use App\Entity\Software;
use Symfony\Component\Serializer\Annotation\Groups;

#[Get(shortName: 'Software')]
final class SoftwareOutput extends AbstractOutput
{
    #[Groups(['software:read', 'software-profile:read'])]
    public string $name;

    #[Groups(['software:read'])]
    public ?string $description = '';

    #[Groups(['software:read', 'software-profile:read'])]
    public ?string $type = '';

    #[Groups(['software:read'])]
    public \DateTime $createdAt;

    #[Groups(['software:read'])]
    public ?string $createdBy = null;

    public function __construct(Software $software)
    {
        parent::__construct($software);

        $this->name = $software->getName();
        $this->description = $software->getDescription();
        $this->type = $software->getType();
        $this->createdAt = $software->getCreatedAt();
        $this->createdBy = $software->getCreatedBy();
    }
}